<div>
  <div class="d-flex justify-content-center">
    <div class="col-md-8">
      <h1 data-cy="registerTitle" jhiTranslate="register.title">Registrierung</h1>

      @if (success()) {
        <div class="alert alert-success" jhiTranslate="register.messages.success">
          <strong>Registrierung gespeichert!</strong> Bitte überprüfen Sie Ihre E-Mails für die Bestätigung.
        </div>
      }

      @if (error()) {
        <div class="alert alert-danger" jhiTranslate="register.messages.error.fail">
          <strong>Registrierung fehlgeschlagen!</strong> Bitte versuchen Sie es später nochmal.
        </div>
      }

      @if (errorUserExists()) {
        <div class="alert alert-danger" jhiTranslate="register.messages.error.userexists">
          <strong>Benutzername bereits vergeben!</strong> Bitte wählen Sie einen anderen aus.
        </div>
      }

      @if (errorEmailExists()) {
        <div class="alert alert-danger" jhiTranslate="register.messages.error.emailexists">
          <strong>E-Mail-Adresse wird bereits verwendet!</strong> Bitte wählen Sie eine andere aus.
        </div>
      }

      @if (doNotMatch()) {
        <div class="alert alert-danger" jhiTranslate="global.messages.error.dontmatch">
          Das bestätigte Passwort entspricht nicht dem neuen Passwort!
        </div>
      }
    </div>
  </div>

  <div class="d-flex justify-content-center">
    <div class="col-md-8">
      @if (!success()) {
        <form name="form" (ngSubmit)="register()" [formGroup]="registerForm">
          <div class="mb-3">
            <label class="form-label" for="login" jhiTranslate="global.form.username.label">Benutzername</label>
            <input
              type="text"
              class="form-control"
              id="login"
              name="login"
              placeholder="{{ 'global.form.username.placeholder' | translate }}"
              formControlName="login"
              data-cy="username"
              #login
            />

            @if (registerForm.get('login')!.invalid && (registerForm.get('login')!.dirty || registerForm.get('login')!.touched)) {
              <div>
                @if (registerForm.get('login')?.errors?.required) {
                  <small class="form-text text-danger" jhiTranslate="register.messages.validate.login.required"
                    >Ihr Benutzername wird benötigt.</small
                  >
                }

                @if (registerForm.get('login')?.errors?.minlength) {
                  <small class="form-text text-danger" jhiTranslate="register.messages.validate.login.minlength"
                    >Ihr Benutzername muss mindestens ein Zeichen lang sein.</small
                  >
                }

                @if (registerForm.get('login')?.errors?.maxlength) {
                  <small class="form-text text-danger" jhiTranslate="register.messages.validate.login.maxlength"
                    >Ihr Benutzername darf nicht länger als 50 Zeichen sein.</small
                  >
                }

                @if (registerForm.get('login')?.errors?.pattern) {
                  <small class="form-text text-danger" jhiTranslate="register.messages.validate.login.pattern"
                    >Ihr Benutzername ist ungültig.</small
                  >
                }
              </div>
            }
          </div>

          <div class="mb-3">
            <label class="form-label" for="email" jhiTranslate="global.form.email.label">Email Adresse</label>
            <input
              type="email"
              class="form-control"
              id="email"
              name="email"
              placeholder="{{ 'global.form.email.placeholder' | translate }}"
              formControlName="email"
              data-cy="email"
            />

            @if (registerForm.get('email')!.invalid && (registerForm.get('email')!.dirty || registerForm.get('email')!.touched)) {
              <div>
                @if (registerForm.get('email')?.errors?.required) {
                  <small class="form-text text-danger" jhiTranslate="global.messages.validate.email.required"
                    >Ihre Email Adresse wird benötigt.</small
                  >
                }

                @if (registerForm.get('email')?.errors?.invalid) {
                  <small class="form-text text-danger" jhiTranslate="global.messages.validate.email.invalid"
                    >Ihre Email Adresse ist ungültig.</small
                  >
                }

                @if (registerForm.get('email')?.errors?.minlength) {
                  <small class="form-text text-danger" jhiTranslate="global.messages.validate.email.minlength"
                    >Ihre Email Adresse muss mindestens 5 Zeichen lang sein</small
                  >
                }

                @if (registerForm.get('email')?.errors?.maxlength) {
                  <small class="form-text text-danger" jhiTranslate="global.messages.validate.email.maxlength"
                    >Ihre Email Adresse darf nicht länger als 50 Zeichen sein</small
                  >
                }
              </div>
            }
          </div>

          <div class="mb-3">
            <label class="form-label" for="password" jhiTranslate="global.form.newpassword.label">Neues Passwort</label>
            <input
              type="password"
              class="form-control"
              id="password"
              name="password"
              placeholder="{{ 'global.form.newpassword.placeholder' | translate }}"
              formControlName="password"
              data-cy="firstPassword"
            />

            @if (registerForm.get('password')!.invalid && (registerForm.get('password')!.dirty || registerForm.get('password')!.touched)) {
              <div>
                @if (registerForm.get('password')?.errors?.required) {
                  <small class="form-text text-danger" jhiTranslate="global.messages.validate.newpassword.required"
                    >Ein neues Passwort wird benötigt.</small
                  >
                }

                @if (registerForm.get('password')?.errors?.minlength) {
                  <small class="form-text text-danger" jhiTranslate="global.messages.validate.newpassword.minlength"
                    >Das neue Passwort muss mindestens 4 Zeichen lang sein</small
                  >
                }

                @if (registerForm.get('password')?.errors?.maxlength) {
                  <small class="form-text text-danger" jhiTranslate="global.messages.validate.newpassword.maxlength"
                    >Das neue Passwort darf nicht länger als 50 Zeichen sein</small
                  >
                }
              </div>
            }

            <jhi-password-strength-bar [passwordToCheck]="registerForm.get('password')!.value"></jhi-password-strength-bar>
          </div>

          <div class="mb-3">
            <label class="form-label" for="confirmPassword" jhiTranslate="global.form.confirmpassword.label"
              >Neues Passwort bestätigen</label
            >
            <input
              type="password"
              class="form-control"
              id="confirmPassword"
              name="confirmPassword"
              placeholder="{{ 'global.form.confirmpassword.placeholder' | translate }}"
              formControlName="confirmPassword"
              data-cy="secondPassword"
            />

            @if (
              registerForm.get('confirmPassword')!.invalid &&
              (registerForm.get('confirmPassword')!.dirty || registerForm.get('confirmPassword')!.touched)
            ) {
              <div>
                @if (registerForm.get('confirmPassword')?.errors?.required) {
                  <small class="form-text text-danger" jhiTranslate="global.messages.validate.confirmpassword.required"
                    >Sie müssen das Passwort bestätigen.</small
                  >
                }

                @if (registerForm.get('confirmPassword')?.errors?.minlength) {
                  <small class="form-text text-danger" jhiTranslate="global.messages.validate.confirmpassword.minlength"
                    >Das bestätigte Passwort muss mindestens 4 Zeichen lang sein</small
                  >
                }

                @if (registerForm.get('confirmPassword')?.errors?.maxlength) {
                  <small class="form-text text-danger" jhiTranslate="global.messages.validate.confirmpassword.maxlength"
                    >Das bestätigte Passwort darf nicht länger als 50 Zeichen sein</small
                  >
                }
              </div>
            }
          </div>

          <button
            type="submit"
            [disabled]="registerForm.invalid"
            class="btn btn-primary"
            data-cy="submit"
            jhiTranslate="register.form.button"
          >
            Registrieren
          </button>
        </form>
      }

      <div class="mt-3 alert alert-warning">
        <span jhiTranslate="global.messages.info.authenticated.prefix">Wenn Sie sich </span>
        <a class="alert-link" routerLink="/login" jhiTranslate="global.messages.info.authenticated.link">anmelden</a
        ><span jhiTranslate="global.messages.info.authenticated.suffix">
          möchten, versuchen Sie es mit <br />- Administrator (Name=&quot;admin&quot; und Passwort=&quot;admin&quot;)<br />- Benutzer
          (Name=&quot;user&quot; und Passwort=&quot;user&quot;).</span
        >
      </div>
    </div>
  </div>
</div>
